-- Decision
-- Author: Home
-- DateCreated: 5/24/2015 12:13:35 PM
--------------------------------------------------------------
-- κ ڵ Vice Virtuoso ڵ忡 
--------------------------------------------------------------
-- Decision 1
--------------------------------------------------------------
local BuildingMordenSuperGiantWeaponID	= GameInfoTypes["BUILDING_DECISIONS_MORDEN_SUPER_GIANT_WEAPON"]
local EraPostModernID					= GameInfoTypes["ERA_POSTMODERN"]
local CivilisationID					= GameInfoTypes["CIVILIZATION_MORDEN"]
local TechRadarID						= GameInfoTypes["TECH_RADAR"]
local UnitFutureMordenXcomID			= GameInfoTypes["UNIT_XCOM_SQUAD"]
local UnitFutureMordenMechID			= GameInfoTypes["UNIT_MORDEN_MECH"]
local mathCeil							= math.ceil

local Decisions_MordenSuperGiantWeapon = {}
	Decisions_MordenSuperGiantWeapon.Name = "TXT_KEY_DECISIONS_MORDEN_SUPER_GIANT_WEAPON"
	Decisions_MordenSuperGiantWeapon.Desc = "TXT_KEY_DECISIONS_MORDEN_SUPER_GIANT_WEAPON_DESC"
	HookDecisionCivilizationIcon(Decisions_MordenSuperGiantWeapon, "CIVILIZATION_MORDEN")
	Decisions_MordenSuperGiantWeapon.CanFunc = (
	function(pPlayer)
		if (pPlayer:GetCivilizationType() ~= CivilisationID) then
			return false, false
		end

		if load(pPlayer, "Decisions_MordenSuperGiantWeapon") == true then
			Decisions_MordenSuperGiantWeapon.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_MORDEN_SUPER_GIANT_WEAPON_ENACTED_DESC")
			return false, false, true
		end
		
		local iGoldCost = mathCeil(3000 * iMod)
		
		Decisions_MordenSuperGiantWeapon.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_MORDEN_SUPER_GIANT_WEAPON_DESC", iGoldCost)

		if pPlayer:GetGold() < iGoldCost								then return true, false end
		if pPlayer:GetNumResourceAvailable(iMagistrate, false) < 2	 	then return true, false end
		if pPlayer:GetCurrentEra() < EraPostModernID					then return true, false	end

		return true, true
	end
	)
	
	Decisions_MordenSuperGiantWeapon.DoFunc = (
	function(pPlayer)
		local iGoldCost = mathCeil(3000 * iMod)

		pPlayer:ChangeGold(-iGoldCost)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -2)

		for pCity in pPlayer:Cities() do
			pCity:SetNumRealBuilding(GameInfoTypes["BUILDING_DECISIONS_MORDEN_SUPER_GIANT_WEAPON"], 1)
		end

		save(pPlayer, "Decisions_MordenSuperGiantWeapon", true)
	end
	)

	Decisions_MordenSuperGiantWeapon.Monitors = {}
	Decisions_MordenSuperGiantWeapon.Monitors[GameEvents.PlayerDoTurn] =  (
	function(iPlayer)
		if iPlayer < GameDefines.MAX_MAJOR_CIVS then
			local pPlayer = Players[iPlayer]
			if load(pPlayer, "Decisions_MordenSuperGiantWeapon") == true then
				for pCity in pPlayer:Cities() do
					pCity:SetNumRealBuilding(GameInfoTypes["BUILDING_DECISIONS_MORDEN_SUPER_GIANT_WEAPON"], 1)
				end
			end
		end
	end
	)

Decisions_AddCivilisationSpecific(GameInfoTypes["CIVILIZATION_MORDEN"], "Decisions_MordenSuperGiantWeapon", Decisions_MordenSuperGiantWeapon)
--------------------------------------------------------------
-- Decision 2
--------------------------------------------------------------
local Decisions_CallFutureMordenArmy = {}
	Decisions_CallFutureMordenArmy.Name = "TXT_KEY_DECISIONS_CALL_FUTURE_MORDEN_ARMY"
	Decisions_CallFutureMordenArmy.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_CALL_FUTURE_MORDEN_ARMY_DESC")
	HookDecisionCivilizationIcon(Decisions_CallFutureMordenArmy, "CIVILIZATION_MORDEN")
	Decisions_CallFutureMordenArmy.CanFunc = (
	function(pPlayer)
		if (pPlayer:GetCivilizationType() ~= CivilisationID) then
			return false, false
		end

		local iGoldCost = mathCeil(2000 * iMod)

		if load(pPlayer, "Decisions_CallFutureMordenArmy") == true then
			Decisions_CallFutureMordenArmy.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_CALL_FUTURE_MORDEN_ARMY_ENACTED_DESC")
			return false, false, true
		end

		Decisions_CallFutureMordenArmy.Desc = Locale.ConvertTextKey("TXT_KEY_DECISIONS_CALL_FUTURE_MORDEN_ARMY_DESC", iGoldCost)
		
		if pPlayer:GetGold() < iGoldCost								then return true, false end
		if pPlayer:GetNumResourceAvailable(iMagistrate, false) < 1	 	then return true, false end
		if (not Teams[pPlayer:GetTeam()]:IsHasTech(TechRadarID))		then return true, false end

		return true, true
	end
	)
	
	Decisions_CallFutureMordenArmy.DoFunc = (
	function(pPlayer)
		local iGoldCost = mathCeil(2000 * iMod)
		local iCapitalX = pPlayer:GetCapitalCity():GetX()
		local iCapitalY = pPlayer:GetCapitalCity():GetY()
		pPlayer:ChangeGold(-iGoldCost)
		pPlayer:ChangeNumResourceTotal(iMagistrate, -1)
		pPlayer:InitUnit(UnitFutureMordenXcomID, iCapitalX, iCapitalY, UNITAI_ATTACK, DirectionTypes.DIRECTION_SOUTH)
		pPlayer:InitUnit(UnitFutureMordenXcomID, iCapitalX, iCapitalY, UNITAI_ATTACK, DirectionTypes.DIRECTION_SOUTH)
		pPlayer:InitUnit(UnitFutureMordenMechID, iCapitalX, iCapitalY, UNITAI_ATTACK, DirectionTypes.DIRECTION_SOUTH)
		save(pPlayer, "Decisions_CallFutureMordenArmy", true)
	end
	)

Decisions_AddCivilisationSpecific(GameInfoTypes["CIVILIZATION_MORDEN"], "Decisions_CallFutureMordenArmy", Decisions_CallFutureMordenArmy)
